package jp.co.hogehoge.batch;

import jp.co.cam.usax.USAXAnnotations.Transaction;
import jp.co.cam.usax.bmc.BMCFactory;
import jp.co.cam.usax.bmc.BMCIF;
import jp.co.cam.usax.rule.impl.AbstractRuledDataBean;
import jp.co.cam.usax.rule.RuleException;


/**
 * [Batch処理]Batch処理クラスの実装。
 */
@Transaction({"default"})
public class SampleBatch
	extends AbstractRuledDataBean
{
	/** SerialVersionUID */
	private static final long serialVersionUID = 2020L;

    /**
     * 実行制御。
     * @param args　パラメータ
     */
    public static void main(final String[] args)
    {
    	// 処理結果
    	int ret;

    	try (final SampleBatch my = new SampleBatch())
        {
            my.begin(); //　Transaction-begin

            if (my.run()) {
                my.commit(); //　Transaction-commit
            	ret =  0;
            } else {
                my.cancel(); //　Transaction-cancel
            	ret = -1;
            }

        } catch(final Exception ex) {
            ex.printStackTrace();
        	ret = -9;
        }
        System.exit(ret);
    }

    @Override
    public boolean run()
        throws RuleException
    {
    	// BMC:サンプル
    	final BMCIF bmc = BMCFactory.create(this, "SAMPLE_BMC");

    	// 実行
        return bmc.run();
    }
}
